/* 
  File: anneal.h

 */

#include "global.h"
#include "switches.h"

#ifndef CALC_H
#define CALC_H 

#define MAX_BETAS      500

#define MIN_EPS       1
#define REJECT_EPS    70            
#define ACCEPT_EPS    10
#define MIN_SD        10.0
#define INFIN         10000.0

extern double Total_Energy;
extern double Total_Magnet;
extern double Total_Accept;
extern double Tot_Energy_Sq;
extern double Tot_Magnet_Sq;
extern double Tot_Accept_Sq;
extern double Error_Energy;  
extern double Error_Magnet;   
extern double Error_Accept; 

extern double Std_Dev;

extern double Min_Energy[MAX_BETAS];

extern int Num_Reject[MAX_BETAS];
extern int Num_Accept[MAX_BETAS];

extern int Spins[MAXROWS][MAXCOLS];    /* spins */
extern int J[MAXROWS][MAXCOLS][NDIM];     /* couplings */


extern int gl_count;

extern FILE *Bfile;

void   One_Pass ();
double Get_New_Beta ();
int    Terminate (); 
int    Get_Iter ();
double Calc_Overlap ();
void   Save_Spins ();
void   Save_Couplings ();
void   Update_Config ();
void   Calc_Cost ();

#endif
