/*+---------------------------------------------------------------------+
  |				File: beta.h				|
  +---------------------------------------------------------------------+*/

#ifndef	BETA
#define BETA
 
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include "ranmar.h"
#include "params.h"

#define	UP		0
#define	DOWN		1
#define	MAXBETAS	75

void	init_betas();
int	numBs(); 	/* returns number of betas 			*/
int	visitsB();	/* returns number of visits to specified beta 	*/
int	indexB();	/* returns index of current beta 		*/
int	lastBi();	/* returns index of last beta 			*/
double	thisB();	/* returns specified beta		 	*/
double 	tryB();		/* returns a new beta according to the following 
			   procedure (assume current beta has index m):
			   
			   	o generate random number, x
			   	o if m==0 return beta(m+1)
			   	o if m==LAST retunr beta(m-1)
			   	o if x < 0.5 return beta(m+1)
			   	  else return beta(m-1)			*/
int	tryDir();	/* returns direction of proposed beta 		*/
double	deltaB();	/* returns (absolute) difference between current 
			   beta and proposed beta 			*/
void	updateB();	/* current beta := proposed beta 		*/
double	curB();		/* returns current beta 			*/
void	dispB();	/* prints list of all betas to stdout 		*/
void	btest();	/* performs random selection of several betas 	*/

#endif
