/************************************************************************
 *                                                                      *
 *             This software copyrighted by Caltech, 1985.              *
 *                                                                      *
 *             Authors: John Salmon, Steve Otto                         *
 *                                                                      *
 ************************************************************************/

#include <math.h>
#include <fcntl.h>
#include <stdio.h>

#define MULT	1103515245
#define ADD	12345
#define MASK	( 0x7fffffff )
static double _twoto31 = 2147483648.0 ;
static int AAA,BBB;
static int randx;

ranset(seed)
int seed;
{
	int proc;

	AAA= MULT;
	BBB = ADD;
	randx = (AAA*seed + BBB) & MASK;
}

double ranf()
/*
	Return a random double in [0, 1.0)
*/
{
	double retvalue;

	retvalue = randx / _twoto31;
	randx = (AAA*randx+BBB)&MASK;
	return(retvalue);
}


int rand()
{
        int      ret;

        ret = randx;
	randx = (AAA*randx+BBB)&MASK;
        return(ret);
}

        
normal(r1,r2)
/*
	This is the Polar method for normal distributions, as described on or near
page 104 of Knuth, Semi-Numerical Algorithms.  To quote Knuth, "The polar
method is quite slow, but it has essentially perfect accuracy, and it is
very easy to write a program for the polar method..."  'nuf said. Algorithm due
to Box, Muller and Marsaglia.
*/
double *r1,*r2;	/* Output, they are normally distributed, with sigma = 1 */
{
	double v1,v2;	/* uniformly distributed on [-1,1) */
	double s;	/* radius of a point pulled from a uniform circle */
	double foo;	/* a useful intermediate value */
	double ranf();

	do {
		v1 = 2.0*ranf() - 1.0;
		v2 = 2.0*ranf() - 1.0;
		s = v1*v1 + v2*v2;
	} while(s >= 1.0 );
	foo = sqrt( -2.0*log(s)/s );
	*r1 = v1*foo;
	*r2 = v2*foo;
}

