/*******************************************************************************

		2-change and 3-change Monte Carlo Traveling Salesman simulation
		by Steve Otto 3/88
		I'm tired of this neural net junk.

*******************************************************************************/

/***** Includes ********/
#include <usercore.h>
#include <stdio.h>
#include <signal.h>
#include <math.h>
#include <sys/types.h>
#include <sys/times.h>
#include "TSP.h"

/***** Global declarations ******/

#define MAXLEN	100	/* for character strings */
#define MIN_X 0.0
#define MAX_X 1.0
#define MIN_Y 0.0
#define MAX_Y 1.0
#define DRAWING_SEGMENT 1
#define MAX_K	10	/* max k-change */
#define BLOCK	100	/* in annealing run, beta changes this often */

#define TRUE	1
#define FALSE 	0

int n;						/* number of cities */
float beta,temperature;				/* inverse temperature */
int tour[MAX_N];				/* the current tour */
int dist[MAX_N][MAX_N];				/* table of distances */
int MC_flag = FALSE;				/* whether or not we tunnel */
FILE *video_fp=NULL;
float video_temperature;
int exit_flag = FALSE;
struct city {
	int x,y;
	} cities[MAX_N];
int min_length_so_far = MAX_N*SCALE;

static float boxdx[] = { 1.0,0.0,-1.0,0.0 };
static float boxdy[] = { 0.0,1.0,0.0,-1.0 };
static float box_x[] = { MAX_X, MAX_X, MIN_X, MIN_X};
static float box_y[] = { MIN_Y, MAX_Y, MAX_Y, MIN_Y};
int pixwindd();
struct vwsurf vwsurf = DEFAULT_VWSURF(pixwindd);
/************** Top Level driver loop ********************/

main()
{
    char line[MAXLEN];			/* character input line */
    char name[50];
    FILE *fp;
    int i,j;
    int index,seed;
    int numit,show;
    int k_change=3;
    int slot[MAX_K];
    int compute_tour_length();
    float dx,dy;
    float start_temp,end_temp;
    float del_dist;
    int k_value;
    int int_handler();
    int patience;

    init_my_exp();

    printf("2-change and 3-change Monte Carlo Traveling Salesman Simulation\n\n");
    printf("Enter number of cities...");
    scanf("%d",&n);
    printf("Enter name of file containing cities\n");
    scanf("%s",name);
    fp = fopen(name,"r");
    for (i=0;i<MAX_N;++i) {
	    fscanf(fp,"%d %d",&cities[i].x,&cities[i].y);
    }
    fclose(fp);
    for (i=0;i<n;++i) {
    for (j=0;j<n;++j) {
	    dx = cities[i].x - cities[j].x;
	    dy = cities[i].y - cities[j].y;
	    dist[i][j] = (int)(sqrt(dx*dx+dy*dy));
    }
    }
    printf("Input seed...");
    scanf("%d",&seed);
    srand(seed);
    init_tour();
    printf("done\n\n");
    
    initialize_core(BASIC,NOINPUT,TWOD);
    initialize_view_surface(&vwsurf,FALSE);
    select_view_surface(&vwsurf);
    set_viewport_2(0.125,0.875,0.125,0.75);
    set_window(-0.2,1.2,-0.2,1.2);

    do {
	printf("Command? ");
	if (fgets(line,MAXLEN,stdin) == NULL) break;
	switch(line[0]) {
	    case '\0':
		    printf("\n");
	    case '\n':
		    continue;	/* with do, not switch */
	    case 'a':
		    if (MC_flag == FALSE) {
		      printf("Sorry, not in Monte Carlo mode\n");
		    }
		    else{
		      printf("Enter number of iterations, how often to show\n");
		      scanf("%d %d",&numit,&show);
		      printf("Enter starting and finishing temperature\n");
		      scanf("%f %f",&start_temp,&end_temp);
	              signal(SIGINT,int_handler);
		      sweep(k_change,numit,show,start_temp,end_temp);
	              signal(SIGINT,SIG_DFL);
		    }
		    continue;
	    case 'c':
		    printf("Drawing Cities...\n");
		    draw_cities();
		    continue;
	    case 'f':
		    printf("Random k-change. Enter value of k.\n");
		    scanf("%d",&k_value);
                    choose_slots(k_value,slot);
                    do_k_change(k_value,slot,&del_dist);
		    continue;
	    case 'i':
		    init_tour();
		    continue;
	    case 'k':
		    printf("k-change currently was %d, now is",k_change);
		    if (k_change == 2) {
		      k_change = 3;
		      printf(" %d\n",k_change);
		    }
		    else if (k_change == 3) {
		      k_change = 2;
		      printf(" %d\n",k_change);
		    }
		    else {
		      printf("Huh??\n");
		    }
		    continue;
	    case 'l':
		    compute_tour_length();
		    continue;
	    case 'm':
		    if (MC_flag) {
		      MC_flag = FALSE;
		      temperature = 0;
		      printf("MC_flag was TRUE, now FALSE\n");
		    }
		    else {
		      MC_flag = TRUE;
		      printf("MC_flag was FALSE, now TRUE\n");
		    }
		    continue;
            case 'o':
		    printf("3-opting the tour...\n");
	            signal(SIGINT,int_handler);
		    temperature = 0;
		    opt();
	            signal(SIGINT,SIG_DFL);
		    continue;
            case 'p':
		    printf("3-(pseudo)opting the tour...\n");
		    printf("Enter patience number\n");
		    scanf("%d",&patience);
	            signal(SIGINT,int_handler);
		    temperature = 0;
		    pseudo_opt(patience);
	            signal(SIGINT,SIG_DFL);
		    continue;
	    case 'r':
		    printf("Enter filename for tour\n");
		    scanf("%s",name);
		    fp = fopen(name,"r");
		    fscanf(fp,"%d",&min_length_so_far);
		    for (i=0;i<n;++i) {
		      fscanf(fp,"%d",&tour[i]);
		    }
		    fclose(fp);
		    continue;
	    case 's':
		    printf("Enter number of iterations, how often to show\n");
		    scanf("%d %d",&numit,&show);
		    if (MC_flag) {
		      printf("Enter Temperature\n");
		      scanf("%f",&temperature);
		      beta = 1./temperature;
		    }
	            signal(SIGINT,int_handler);
		    sweep(k_change,numit,show,temperature,temperature);
	            signal(SIGINT,SIG_DFL);
		    continue;	
	    case 'S':
		    printf("Enter number of iterations, how often to show\n");
		    scanf("%d %d",&numit,&show);
		    if (MC_flag) {
		      printf("Enter Temperature\n");
		      scanf("%f",&temperature);
		      beta = 1./temperature;
		    }
	            signal(SIGINT,int_handler);
		    Sweep(numit,show,1.0);
	            signal(SIGINT,SIG_DFL);
		    continue;	
	    case 't':
		    printf("Drawing Tour...\n");
		    draw_tour();
		    continue;
	    case 'v':
		    if (video_fp) {
		      fclose(video_fp);
		      printf("Turning off video mode\n");
		    }
		    else {
		      printf("Enter name of file for video record:\n");
		      scanf("%s",name);
		      video_fp = fopen(name,"w");
		      if(video_fp == NULL){
			  printf("Sorry, couldn't open that file.\n");
		      }
		      else{
			  tour_to_video();
		      }
		    }
		    continue;
	    case 'w':
		    printf("Enter filename for tour\n");
		    scanf("%s",name);
		    fp = fopen(name,"w");
		    fprintf(fp,"%d\n",compute_tour_length());
		    for (i=0;i<n;++i) {
		      fprintf(fp,"%d\n",tour[i]);
		    }
		    fclose(fp);
		    continue;
	    case 'x':
		    break;		/* exit */
	    case 'z':
		    printf("Super Monte-Carlo. Enter number of hits, patience factor inside the pseudo-opt.\n");
		    scanf("%d %d",&numit,&patience);
		    if (MC_flag) {
		      printf("Enter Temperature\n");
		      scanf("%f",&temperature);
		      beta = 1./temperature;
		    }
	            signal(SIGINT,int_handler);
		    super_MC(numit,patience,1.0);
	            signal(SIGINT,SIG_DFL);
	    default:
		    help();
		    continue;
	}
	break;
    } while (TRUE);

    delete_all_retained_segments();
    deselect_view_surface(&vwsurf);
    terminate_core();
    printf("\nIt's been real!\n");
}

/****** Assorted subroutines *********************/

help()		/* print out commands available */
{
	printf("Commands are:\n");
	printf("	a		Anneal\n");
	printf("	c		Draw cities\n");
	printf("	f		Make a random 4-change\n");
	printf("	l		Compute distance\n");
	printf("	i		init_tour\n");
	printf("	k		toggle k-change between 2 and 3\n");
	printf("	m		toggle MC_flag\n");
	printf("	o		Opt that sucker\n");
	printf("	p		Pseudo-Opt that sucker\n");
	printf("	r		Read tour from a file\n");
	printf("	s		sweep \n");
	printf("	S		Sweep - higher k-change possible \n");
	printf("	t		Draw tour\n");
	printf("	v		Save tours for video\n");
	printf("	w		Write tour to a file\n");
	printf("	x		Exit from simulation\n");
	printf("	z		zsuper Monte-Carlo\n");
	printf("\n");
}

int compute_tour_length()
{
  int i;
  int length;

  length = 0;
  for (i=0;i<n;++i) {
    length += dist[tour[i]][tour[(i+1)%n]];
  }
  if (length < min_length_so_far) {
    printf("Tour length = %d     --->Best so far\n",length);
    min_length_so_far = length;
  }
  else {
    printf("Tour length = %d\n",length);
  }
  return(length);
}

draw_cities()
{
  int i;
  float size;

  delete_all_retained_segments();
  create_retained_segment(DRAWING_SEGMENT);
  set_fill_index(15);	/* solid black fill */
  for (i=0;i<n;++i) {
    move_abs_2(((float)cities[i].x)/SCALE,((float)cities[i].y)/SCALE);
    size = 0.02;
    draw_box(size);
  }
}

draw_tour()
{
  int i,index,j;
  float size;

  delete_all_retained_segments();
  create_retained_segment(DRAWING_SEGMENT);
  set_fill_index(15);	/* solid black fill */
  for (i=0;i<n;++i) {
    move_abs_2(((float)cities[i].x)/SCALE,((float)cities[i].y)/SCALE);
    size = 0.02;
    draw_box(size);
  }
  j=0;
  index = tour[j];
  move_abs_2(((float)cities[index].x)/SCALE,((float)cities[index].y)/SCALE);
  for (i=0;i<n;++i) {
    j = (j+1)%n;
    index = tour[j];
    line_abs_2(((float)cities[index].x)/SCALE,((float)cities[index].y)/SCALE);
  }
}


sweep(k_change,numit,show,start_temp,end_temp)
int k_change,numit,show;	/* a "sweep" is considered to be n k-changes */
float start_temp,end_temp;      /* starting and ending temperatures  */
{
  int i,j,l,k,temp;
  int slot[3],moving;
  long times(),time_used;
  struct tms buffer;
  int leftmost,middle,rev_flag,mid1,mid2;
  float del_dist;
  float factor;
  int k_value;
  float ranf();
  int compute_tour_length();
  double my_exp();

  factor = log(end_temp/start_temp)/numit;
  times(&buffer);
  time_used = buffer.tms_utime;
  for (l=0;l<numit;++l) {
    temperature = start_temp*exp(factor*l);
    beta = 1.0/temperature;
    if( video_fp && (temperature!=video_temperature) ){
	video_temperature = temperature;
	fprintf(video_fp,"t   %f\n",video_temperature);
    }
    if (exit_flag) {
      exit_flag = FALSE;
      goto out;
    }
    for (k=0;k<n;++k) {
      if (k_change == 2) {
	k_value = 2;
      }
      else {			/* get a mixture */
	if (ranf() >= .5) {
	  k_value = 3;
	}
	else {
	  k_value = 2;
	}
      }
      					/* decide on the move to try */
      choose_slots(k_value,slot);
      if (k_value == 2) {
	leftmost = (slot[0]-1+n)%n;
	middle = (slot[1]-1+n)%n;
        del_dist = dist[tour[leftmost]][tour[middle]] -
		  dist[tour[leftmost]][tour[slot[0]]] +
		  dist[tour[slot[0]]][tour[slot[1]]] -
		  dist[tour[middle]][tour[slot[1]]];
	if (MC_flag) {		/* good 'ole Metropolis */	
          if (del_dist < 0.0) {
	    two_change(slot);
	  }
	  else if (ranf() < my_exp(-beta*del_dist)) {
	    two_change(slot);
	  }
	}
	else {
          if (del_dist < 0.0) {
	    two_change(slot);
	  }
	}
      }
      else if (k_value == 3) {
	leftmost = (slot[0]-1+n)%n;
	mid1 = (slot[1]-1+n)%n;
	mid2 = (slot[2]-1+n)%n;
	if (ranf() < .5) {
	  rev_flag = TRUE;
	  del_dist = dist[tour[leftmost]][tour[mid2]] -
		     dist[tour[leftmost]][tour[slot[0]]] +
		     dist[tour[slot[1]]][tour[slot[0]]] -
		     dist[tour[slot[1]]][tour[mid1]] +
		     dist[tour[mid1]][tour[slot[2]]] -
		     dist[tour[slot[2]]][tour[mid2]];
	}
	else {
	  rev_flag = FALSE;
	  del_dist = dist[tour[leftmost]][tour[slot[1]]] -
		     dist[tour[leftmost]][tour[slot[0]]] +
		     dist[tour[mid2]][tour[slot[0]]] -
		     dist[tour[mid2]][tour[slot[2]]] +
		     dist[tour[mid1]][tour[slot[2]]] -
		     dist[tour[mid1]][tour[slot[1]]];
	}
	if (MC_flag) {
          if (del_dist < 0.0) {
	    three_change(slot,rev_flag);
	  }
	  else if (ranf() < my_exp(-beta*del_dist)) {
	    three_change(slot,rev_flag);
	  }
	}
	else {
          if (del_dist < 0.0) {
	    three_change(slot,rev_flag);
	  }
	}
      }
    }
    if ((l+1)%show == 0) {
      draw_tour();
      printf("T = %f  ",temperature);
      compute_tour_length();
    }
  }
out:
  times(&buffer);
  time_used = buffer.tms_utime - time_used;
  printf("%d sweeps took %d seconds\n",l,time_used/60);
}

Sweep(numit,show,factor)	/* version for general k-changes */
int numit,show;			/* a "sweep" is considered to be n k-changes */
float factor;			/* multiply beta by factor after each sweep  */
{
  float Prob_of_k[MAX_K];
  int slot[MAX_K],moving;
  int i,j,l,k,temp;
  long times(),time_used;
  struct tms buffer;
  float Prob_sum;
  int k_value,k_max;
  float ranf(),r;
  int compute_tour_length();

  printf("General k-change update. Enter max value of k.\n");
  scanf("%d",&k_max);
  Prob_of_k[0] = 0.0;	/* no 1-changes */
  printf("Probility of a 1-change has been set to 0.0\n");
  do {
    Prob_sum = 0.0;
    for (i=1;i<k_max;++i) {
      printf("Enter Probability of %d-change\n",i+1);
      scanf("%f",&Prob_of_k[i]);
      Prob_sum += Prob_of_k[i];
    }
    if ((Prob_sum<.999) || (Prob_sum>1.0001)) {
      printf("Sum of probabilities = %f -- not 1.0! -- try again.\n",Prob_sum);
    }
  } while ((Prob_sum<.999) || (Prob_sum>1.0001));
  for (i=1;i<k_max;++i) {	/* now they are cumulative Probs */
    Prob_sum = 0.0;
    for (j=i;j<k_max;++j) {
      Prob_sum += Prob_of_k[j];
    }
    Prob_of_k[i] = Prob_sum;
  }
  times(&buffer);
  time_used = buffer.tms_utime;
  for (l=0;l<numit;++l) {
    if (exit_flag) {
      exit_flag = FALSE;
      goto out;
    }
    for (k=0;k<n;++k) {
      r = ranf();
      k_value = 0;
      while (r < Prob_of_k[++k_value]);		/* pick k_value */
      					/* decide on the move to try */
      choose_slots(k_value,slot);
      k_update(k_value,slot);
    }
    if ((l+1)%show == 0) {
      draw_tour();
      printf("T = %f  ",temperature);
      compute_tour_length();
    }
    if ((l+1)%BLOCK == 0) {
      beta *= factor;
      temperature /= factor;
    }
  }
out:
  times(&buffer);
  time_used = buffer.tms_utime - time_used;
  printf("%d Sweeps took %d seconds\n",l,time_used/60);
}

two_change(slot)
int slot[];
{
  int i,j,k;
  int temp_tour[MAX_N];
  int middle;

  if(video_fp){
    if(temperature != video_temperature){
	video_temperature = temperature;
	fprintf(video_fp,"t    %f\n",video_temperature);
    }
    fprintf(video_fp,"2   %d %d\n",slot[0],slot[1]);
  }

  middle = (slot[1]-1+n)%n;
  for (j=middle,k=0; ;j=(j-1+n)%n,++k) {	/* take out and reverse */
    temp_tour[k] = tour[j];
    if (j == slot[0]) {
      break;
    }
  }
  for (j=slot[0],k=0; ;j=(j+1)%n,++k) {/* put back */
    tour[j] = temp_tour[k];
    if (j == middle) {
      break;
    }
  }
}

three_change(slot,rev_flag)
int slot[],rev_flag;
{
  int i,j,k,count;
  int temp_tour[MAX_N];
  int mid1,mid2;

  if(video_fp){
    if(temperature != video_temperature){
	video_temperature = temperature;
	fprintf(video_fp,"t    %f\n",video_temperature);
    }
    fprintf(video_fp,"3    %d %d %d   %d\n",slot[0],slot[1],slot[2],rev_flag);
  }

  mid1 = (slot[1]-1+n)%n;
  mid2 = (slot[2]-1+n)%n;
  				/* take out second segment ... */
  if (rev_flag) {		/* reverse? */
    for (j=mid2,k=0; ;j=(j-1+n)%n) {	
      temp_tour[k++] = tour[j];
      if (j == slot[1]) {
	break;
      }
    }
  }
  else {
    for (j=slot[1],k=0; ;j=(j+1)%n) {	
      temp_tour[k++] = tour[j];
      if (j == mid2) {
	break;
      }
    }
  }
  count = k;
				/* now slide ... */
  for (j=mid1,k=mid2; ;j=(j-1+n)%n,k=(k-1+n)%n) {
    tour[k] = tour[j];
    if (j == slot[0]) {
      break;
    }
  }
				/* and put temp_tour in the open space */
  for (j=0,k=slot[0];j<count;++j,k=(k+1)%n) {
    tour[k] = temp_tour[j];
  }
}

k_update(k_change,slot)
int k_change,slot[];
{
  int i;
  int shadow_tour[MAX_N];
  float del_dist;
  double my_exp();

  for (i=0;i<n;++i) {		/* in case move is rejected */
    shadow_tour[i] = tour[i];	
  }
  del_dist = 0.0;
  do_k_change(k_change,slot,&del_dist);
  if (MC_flag) {
    if (del_dist < 0.0) {
      ;				/* move is already made */
    }
    else if (ranf() < my_exp(-beta*del_dist)) {
      ;				/* move is already made */
    }
    else {
      for (i=0;i<n;++i) {	/* come back */
        tour[i] = shadow_tour[i];	
      }
    }
  }
  else {
    if (del_dist < 0.0) {
      ;				/* move is already made */
    }
    else {
      for (i=0;i<n;++i) {	/* come back */
        tour[i] = shadow_tour[i];	
      }
    }
  }
}

do_k_change(k_change,slot,pdel_dist)
int k_change,slot[];
float *pdel_dist;
{
  int i,j,k,index,middle,count,mid2,mid1,segment;
  int bit_o_tour[MAX_N];
  float ranf();

  if (k_change == 1) {
    return;
  }
  index = (int)(ranf()*(float)(k_change-1));
			/* break the bonds of the segment to be removed */
  *pdel_dist -= dist[tour[slot[index]]][tour[(slot[index]-1+n)%n]];
  *pdel_dist -= dist[tour[slot[index+1]]][tour[(slot[index+1]-1+n)%n]];
  if (ranf() < .5) {				/* reverse bit */
    middle = (slot[index+1]-1+n)%n;
    for (j=middle,k=0; ;j=(j-1+n)%n) {		/* take out and reverse */
      bit_o_tour[k++] = tour[j];
      if (j == slot[index]) {
        break;
      }
    }
    count = k;
  }
  else {					/* don't */
    middle = (slot[index+1]-1+n)%n;
    for (j=slot[index],k=0; ;j=(j+1)%n) {	/* take out */
      bit_o_tour[k++] = tour[j];
      if (j == middle) {
        break;
      }
    }
    count = k;
  }
  if (index > 0) {		/* if sliding, there is a bond to break, */
    *pdel_dist -= dist[tour[slot[0]]][tour[(slot[0]-1+n)%n]];
				/* and one to add. */
    *pdel_dist += dist[tour[slot[index+1]]][tour[(slot[index]-1+n)%n]];
				/* now slide one segment at a time */
    j = (slot[index]-1+n)%n;
    k = (slot[index+1]-1+n)%n;
    for (segment=index-1;segment>=0;--segment) {
      for ( ; ;j=(j-1+n)%n,k=(k-1+n)%n) {
        tour[k] = tour[j];
        if (j == slot[segment]) {
	  j=(j-1+n)%n;
	  k=(k-1+n)%n;
	  break;
        }
      }
      slot[segment+1] = (slot[segment]+count)%n;/* slide, update slot array */
    }
  }
				/* and put bit_o_tour in the open space */
  for (j=0,k=slot[0];j<count;++j,k=(k+1)%n) {
    tour[k] = bit_o_tour[j];
    if (j == 0) {		/* add bonds for new bit */
      *pdel_dist += dist[tour[k]][tour[(k-1+n)%n]];
    }
    if (j == count-1) {
      *pdel_dist += dist[tour[k]][tour[(k+1)%n]];
    }
  }
  for (segment=0;segment<k_change-1;++segment) {/* slot[0] is now gone */
    slot[segment] = slot[segment+1];
  }
  do_k_change(k_change-1,slot,pdel_dist);	/* recurse! */
}


draw_box(size)
float size;
{
	int i;
	float newboxdx[10],newboxdy[10];

	for (i=0;i<5;++i) {
		newboxdx[i] = boxdx[i]*size*0.8;
		newboxdy[i] = boxdy[i]*size*0.8;
	}
	move_rel_2(-0.4*size,-0.4*size);
	polygon_rel_2(newboxdx,newboxdy, 4);
}

#define MULT	1103515245
#define ADD	12345
#define MASK	( 0x7fffffff )
static double _two_to_31 = 2147483648.0 ;
static int _randx;

srand(seed)
int seed;
{
  _randx = seed;
}

float ranf()
{
  _randx = (MULT * _randx + ADD) & MASK;
  return( _randx / _two_to_31 );
}

init_tour()
{			/* random initial assignment */
  int i,j,k;
  float ranf();
  int slot,free_slots[MAX_N],num_free_slots;

  num_free_slots = 0;
  for (i=0;i<n;++i) {		/* all slots start off free */
    free_slots[num_free_slots++] = i;
  }
  for (i=0;i<n;++i) {		/* loop through cities and assign */
    slot = (int)(num_free_slots*ranf());
    tour[free_slots[slot]] = i;
    for (j=slot;j<num_free_slots-1;++j) {
      free_slots[j] = free_slots[j+1];
    }
    --num_free_slots;
  }
  
}



/*
 *	tabulated exponential function for simulated annealing
 *
 *	we know argument will always be <= 0.0
 *	just return zero if argument <= -10.0
 *	use a coarse table between 1 and 10, and
 *	a fine table between 0 and 1
 */


#define RESOLUTION  10000    /* this many tabulated points between 0 and 1 */
#define CUTOFF      20       /* greatest value of argument for nonzero value  */

double fine_scale[RESOLUTION];
double coarse_scale[CUTOFF];


init_my_exp()
{
    int     i;

    for(i=0; i<CUTOFF; ++i){
	coarse_scale[i] = exp((double)(-i));
    }

    for(i=0; i<RESOLUTION; ++i){
	fine_scale[i] = exp(((double)(-i))/((double)RESOLUTION));
    }
}


double my_exp(arg)
    double  arg;
{
    int     coarse,fine;

    arg = -arg;
    if(arg >= CUTOFF){
	return(0.0);
    }

    coarse = (int)arg;
    fine = (int)(RESOLUTION*(arg-coarse));
    return(coarse_scale[coarse]*fine_scale[fine]);
}

choose_slots(k_value,slot)
int k_value,slot[];
{
  int i,j,temp,moving;
  float ranf();

  slot[0] = (int)(ranf()*n);	/* first place at random; */
				/* new "start" of tour */
  for (j=1;j<k_value;++j) {
try:	slot[j] = (int)(ranf()*n);
    for (i=0;i<j;++i) {
      if ((slot[j]==slot[i])) {
	goto try;
      }
    }
  }
  /* we want a permutation of sorted slots; get this by sorting k-1 */
  /* slots above first, using as key distance from first */
  do {				/* bubblesort the slots */
    moving = FALSE;
    for (j=1;j<k_value-1;++j) {
      if ((slot[j]-slot[0]+n)%n > (slot[j+1]-slot[0]+n)%n) {
	temp = slot[j];
	slot[j] = slot[j+1];
	slot[j+1] = temp;
	moving = TRUE;
      }
    }
  } while (moving);
}

opt()
{
  int i,j,l,k,temp;
  int slot[3],moving;
  long times(),time_used;
  struct tms buffer;
  int leftmost,middle,rev_flag,mid1,mid2;
  float del_dist;
  int compute_tour_length();
  int repeat=0,last_length;

  last_length = compute_tour_length();
  times(&buffer);
  time_used = buffer.tms_utime;
  l = 0;
  do {
    for (slot[0]=0;slot[0]<n;++slot[0]) {		/* 2-opt */
      for (slot[1]=(slot[0]+1)%n; ;slot[1]=(slot[1]+1)%n) {
        leftmost = (slot[0]-1+n)%n;
        middle = (slot[1]-1+n)%n;
        del_dist = dist[tour[leftmost]][tour[middle]] -
	           dist[tour[leftmost]][tour[slot[0]]] +
		   dist[tour[slot[0]]][tour[slot[1]]] -
		   dist[tour[middle]][tour[slot[1]]];
        if (del_dist < 0.0) {
	  two_change(slot);
	}
	if (slot[1] == (slot[0]-1+n)%n) {
	  break;
	}
      }
    }
    draw_tour();
    printf("Done with 2-change sweep... ");
    temp = compute_tour_length();
    if (temp == last_length) {
      ++repeat;
      if (repeat == 2) {
	break;
      }
    }
    else {
      repeat = 0;
      last_length = temp;
    }
    for (slot[0]=0;slot[0]<n;++slot[0]) {		/* 3-opt */
      for (slot[1]=(slot[0]+1)%n; ;slot[1]=(slot[1]+1)%n) {
	if (exit_flag) {
	  exit_flag = FALSE;
	  goto out;
	}
	for (slot[2]=(slot[1]+1)%n; ;slot[2]=(slot[2]+1)%n) {
	  leftmost = (slot[0]-1+n)%n;
	  mid1 = (slot[1]-1+n)%n;
	  mid2 = (slot[2]-1+n)%n;
	  rev_flag = TRUE;
	  del_dist = dist[tour[leftmost]][tour[mid2]] -
	             dist[tour[leftmost]][tour[slot[0]]] +
	             dist[tour[slot[1]]][tour[slot[0]]] -
	             dist[tour[slot[1]]][tour[mid1]] +
	             dist[tour[mid1]][tour[slot[2]]] -
	             dist[tour[slot[2]]][tour[mid2]];
          if (del_dist < 0.0) {
	    three_change(slot,rev_flag);
	  }
	  rev_flag = FALSE;
	  del_dist = dist[tour[leftmost]][tour[slot[1]]] -
	             dist[tour[leftmost]][tour[slot[0]]] +
	             dist[tour[mid2]][tour[slot[0]]] -
	             dist[tour[mid2]][tour[slot[2]]] +
	             dist[tour[mid1]][tour[slot[2]]] -
	             dist[tour[mid1]][tour[slot[1]]];
          if (del_dist < 0.0) {
	    three_change(slot,rev_flag);
	  }
	  if (slot[2] == (slot[0]-1+n)%n) {
	    break;
	  }
	}
	if (slot[1] == (slot[0]-2+n)%n) {
	  break;
	}
      }
    }
    draw_tour();
    printf("Done with 3-change sweep... ");
    temp = compute_tour_length();
    if (temp == last_length) {
      ++repeat;
    }
    else {
      repeat = 0;
      last_length = temp;
    }
    ++l;
  } while (repeat < 2);
out:
  times(&buffer);
  time_used = buffer.tms_utime - time_used;
  draw_tour();
  printf("Tour is 3-opt.  ");
  compute_tour_length();
  printf("%d sweeps took %d seconds\n",l,time_used/60);
}

pseudo_opt(patience)
int patience;
{
  int i,j,l,k,temp;
  int slot[3],moving,doing_two;
  long times(),time_used;
  struct tms buffer;
  int leftmost,middle,rev_flag,mid1,mid2;
  float del_dist;
  int compute_tour_length();
  int time_since_last_move;

  times(&buffer);
  time_used = buffer.tms_utime;
  l = 0;
  time_since_last_move = 0;
  doing_two = TRUE;
  do {
    if(doing_two){
      doing_two = FALSE;
      for (slot[0]=0;slot[0]<n;++slot[0]) {		/* 2-opt */
        for (slot[1]=(slot[0]+1)%n; ;slot[1]=(slot[1]+1)%n) {
          leftmost = (slot[0]-1+n)%n;
          middle = (slot[1]-1+n)%n;
          del_dist = dist[tour[leftmost]][tour[middle]] -
	             dist[tour[leftmost]][tour[slot[0]]] +
		     dist[tour[slot[0]]][tour[slot[1]]] -
		     dist[tour[middle]][tour[slot[1]]];
          if (del_dist < 0.0) {
	    two_change(slot);
            doing_two = TRUE;
	  }
	  if (slot[1] == (slot[0]-1+n)%n) {
	    break;
	  }
        }
      }
      draw_tour();
      printf("Done with 2-change sweep... ");
      compute_tour_length();
    }
    moving = FALSE;
    for (k=0;k<n*n;++k) {		/* do N^2 3-changes */
	if (exit_flag) {
	  exit_flag = FALSE;
	  goto out;
	}
        choose_slots(3,slot);		/* pick location at random */
	leftmost = (slot[0]-1+n)%n;
	mid1 = (slot[1]-1+n)%n;
	mid2 = (slot[2]-1+n)%n;
	rev_flag = TRUE;
	del_dist = dist[tour[leftmost]][tour[mid2]] -
	           dist[tour[leftmost]][tour[slot[0]]] +
	           dist[tour[slot[1]]][tour[slot[0]]] -
	           dist[tour[slot[1]]][tour[mid1]] +
	           dist[tour[mid1]][tour[slot[2]]] -
	           dist[tour[slot[2]]][tour[mid2]];
        if (del_dist < 0.0) {
	  three_change(slot,rev_flag);
	  moving = TRUE;
	}
	rev_flag = FALSE;
	del_dist = dist[tour[leftmost]][tour[slot[1]]] -
	           dist[tour[leftmost]][tour[slot[0]]] +
	           dist[tour[mid2]][tour[slot[0]]] -
	           dist[tour[mid2]][tour[slot[2]]] +
	           dist[tour[mid1]][tour[slot[2]]] -
	           dist[tour[mid1]][tour[slot[1]]];
        if (del_dist < 0.0) {
	  three_change(slot,rev_flag);
	  moving = TRUE;
	}
    }
    if (moving) {
      time_since_last_move = 0;
      doing_two = TRUE;
    }
    else {
      ++time_since_last_move;
    }
    draw_tour();
    printf("Done with 3-change sweep... ");
    compute_tour_length();
    ++l;
  } while (time_since_last_move < patience);
out:
  times(&buffer);
  time_used = buffer.tms_utime - time_used;
  draw_tour();
  printf("Tour is 3-opt.  ");
  compute_tour_length();
  printf("%d sweeps took %d seconds\n",l,time_used/60);
}

int_handler()
{
  signal(SIGINT,SIG_DFL);	/* restore normal operation of ^C */
  printf("OK - I heard you - I will finish soon.\n");
  exit_flag = TRUE;		/* causes it to exit next time round */
}

super_MC(num_hits,patience,factor)
int num_hits,patience;
float factor;
{
  int i,j,l,k,temp;
  long times(),time_used;
  struct tms buffer;
  float del_dist,old_dist,new_dist;
  float ranf();
  int slot[MAX_K];
  int shadow_tour[MAX_N];
  int compute_tour_length();
  double my_exp();

  times(&buffer);
  time_used = buffer.tms_utime;
  for (l=0;l<num_hits;++l) {
    if (exit_flag) {
      exit_flag = FALSE;
      goto out;
    }
    for (i=0;i<n;++i) {		/* in case move is rejected */
      shadow_tour[i] = tour[i];	
    }
    old_dist = compute_tour_length();
    choose_slots(6,slot);	/* the 'super_move' */
    do_k_change(6,slot,&del_dist);
    pseudo_opt(patience);
    new_dist = compute_tour_length();
    del_dist = new_dist - old_dist;
    if (MC_flag) {		/* good 'ole Metropolis */	
      if (del_dist < 0.0) {
        printf("move is accepted\n");	/* move is already made */
      }
      else if (ranf() < my_exp(-beta*del_dist)) {
        printf("move is accepted\n");	/* move is already made */
      }
      else {
        printf("move is rejected\n");
        for (i=0;i<n;++i) {	/* come back */
          tour[i] = shadow_tour[i];	
        }
      }
    }
    else {
      if (del_dist < 0.0) {
        printf("move is accepted\n");	/* move is already made */
      }
      else {
        printf("move is rejected\n");
        for (i=0;i<n;++i) {	/* come back */
          tour[i] = shadow_tour[i];	
        }
      }
    }
    draw_tour();
    printf("T = %f  ",temperature);
    compute_tour_length();
    if ((l+1)%BLOCK == 0) {
      beta *= factor;
      temperature /= factor;
    }
  }
out:
  times(&buffer);
  time_used = buffer.tms_utime - time_used;
  printf("%d hits took %d seconds\n",l,time_used/60);
}


tour_to_video()
{
    int     i;

    for(i=0; i<n; ++i){
	fprintf(video_fp,"%d\n",tour[i]);
    }
    fprintf(video_fp,"\n");

    video_temperature = temperature;
    fprintf(video_fp,"t    %f\n",video_temperature);
}

