
From: 
 Dr. David K. Kahaner
 US Office of Naval Research Asia
 (From outside US):  23-17, 7-chome, Roppongi, Minato-ku, Tokyo 106 Japan
 (From within  US):  Unit 45002, APO AP 96337-0007
  Tel: +81 3 3401-8924, Fax: +81 3 3403-9670
  Email: kahaner@cs.titech.ac.jp
Re: Fujitsu's 2nd Parallel Computing WS (PCW'93) 11/93 Kawasaki Japan
12/28/93 (MM/DD/YY)
This file is named "ap1000ws.93"

ABSTRACT. Fujitsu's second Parallel Computing Workshop (PCW'93), held
Nov 11 1993 at Fujitsu's Parallel Computing Research Facilities,
Kawasaki Japan, is summarized. PCW is an opportunity for researchers who
are using Fujitsu's AP1000 distributed memory parallel computer to
describe their work. Significant collaborations are reported between the
Australian National University and Fujitsu.


----------------------------------------------------------------------

ABSTRACTS OF PAPERS PRESENTED AT FUJITSU'S 2ND PARALLEL COMPUTING WORKSHOP
               11 NOV 1993, KAWASAKI JAPAN

Simulated Annealing Heuristics for Static Task Assignment
Kazuo Horikawa et al.
Department of Information Science
Faculty of Engineering, Kyoto University

As an approach to the static task assignment problem for parallel
applications, we propose a modification of simulated annealing.  In
order to speed up the convergence of this method, we exploit heuristics
to calculate the generation probabilities of neighboring solutions.  We
have proposed two heuristics for load balancing and one heuristics for
reduction of interprocessor communication.  And we examined their effect
using some random TIGs.  The results proved that the former heuristics
are very effective at the beginning of the annealing process, while the
latter improves the score after certain feasible load balance was
achieved by the former heuristics.  Parallel execution of functional
programs on loosely coupled multiprocessor systems

-------------------------------------------------------------

A new technique to improve parallel automated single layer wire routing
Hesham Keshk et al.
Department of Information Science
Kyoto University
Yoshida-hon-machi
Sakyo-ku, Kyoto 606-01

Automated wire routing is to find a path between two or more network
pins and this path must not intersect with previous drawn paths.  The
basic problems of automated wire routing are the long computation time
and large memory size required.  Recently, several researches tried to
speed up the routing problem by using parallel computers.  We develop
two parallel algorithms based on maze running algorithm.  Both of them
have a new technique in dividing a single layer grid.  These two
algorithms give high speed specially if the net lengths are small with
respect to gird dimensions.  In the first algorithm, moving boundaries
are used in dividing the grid.  The second algorithm can be divided into
two phases.  In the first phase, we rotate the areas assigned to the
processors to route all short nets.  In the second phase we use the
competing processors algorithm to route the remaining nets.
-------------------------------------------------------------

Parallel Speculative Computation of Simulated Annealing on the AP1000
Multiprocessor
Andrew Sohn
Dept. of Computer and Information Science
New Jersey Institute of Technology
Newark, NJ 07102-1982

Simulated annealing is known to be highly sequential due to loop-
carried dependencies.  While the conventional speculative computation
with a binary tree has been found effective for parallel simulated
annealing, its performance is limited to (log n)-fold speedup on n
processors due to parallel execution of log n iterations.  This report
presents a new approach to parallel simulated annealing, called
generalized speculative computation (GSC).  We use an n-array
speculative tree and loop indices to execute n iterations in parallel on
n processors while maintaining the same decision sequence as sequential
simulated annealing.  To verify the performance of GSC, we implement 100
to 500-city Traveling Salesman Problems on the AP1000 massively parallel
multiprocessor.  Actual execution results demonstrate that the new GSC
approach can indeed be an effective method for parallel simulated
annealing.  We obtain over 20-fold speedup for the initial temperature
of 0.1 and 11-fold speedup for the initial temperature of 10, all on 100
processors.
-------------------------------------------------------------

A Parallel Genetic Algorithm Retaining Sequential Behaviors on
Distributed-Memory Multiprocessors
Jongho Nang
IIAS-SIS
Fujitsu Laboratories Ltd.
1-9-3 Nakase
Mihama-ku, Chiba-shi 261

This paper proposes a simple and efficient parallelizing scheme of the
genetic algorithm on distributed-memory multiprocessor that allows to
maintain the execution behaviors of sequential genetic algorithm.  In
this parallelizing scheme, the global population is evenly partitioned
into several subpopulations each of which is assigned to the processor
to be evolved in parallel.  An interprocessor communication pattern,
called AAB (All-To-All Broadcasting), is used at each generation in
order to exchange the information on all individuals evolved in all
other processors.  It allows the processor to reproduce the individuals
in a global sense, in other words, the sequential execution behaviors
can be maintained in the parallelized genetic algorithm.  This paper
shows that the genetic algorithms employing widely used selection
schemes such as proportionate selection, ranking selection, and
tournament selection can be efficiently parallelized on
distributed-memory multiprocessor using the proposed parallelizing
scheme.  Some experimental speedups on AP1000 are also presented to show
the usefulness of the proposed parallelizing scheme.

--------------------------------END OF REPORT-----------------------





